'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _dataTree = require('./helpers/dataTree');

var _dataTree2 = _interopRequireDefault(_dataTree);

var _util = require('./helpers/util');

var _timers = require('timers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Select = function (_React$Component) {
  _inherits(Select, _React$Component);

  function Select(props) {
    _classCallCheck(this, Select);

    var _this = _possibleConstructorReturn(this, (Select.__proto__ || Object.getPrototypeOf(Select)).call(this, props));

    ['onExpand', 'onSelect', 'onCheck', 'onChange', 'toggleMenuVisible', 'handleSearchInputChange', 'handleDocumentClick'].forEach(function (m) {
      _this[m] = _this[m].bind(_this);
    });

    _this.state = {
      /**
       * 用于渲染下拉菜单的数据，取自于Tree.props.data或List.props.data
       * 因为有搜索功能，这个data在搜索时会发生变化，所以需要在这里维护
       * @type {[type]}
       */
      data: [],
      /**
       * 显示、隐藏下拉菜单的标识
       * @type {Boolean}
       */
      menuVisible: false,
      /**
       * 树节点展开列表（搜索时用到，这里需要接管Tree.props.expanded）
       * @type {Array}
       */
      expanded: [],
      /**
       * 下拉框在选择后，输入框显示的值
       * @type {String}
       */
      inputValue: props.inputValue,
      /**
       * 搜索框显示的值
       * @type {String}
       */
      searchInputValue: ''
      /**
       * 初始化状态标识
       * 数据一般都是异步加载，在生成Component时，由于props.data为空，导致props.defaultChecked等值无效
       * 这里折中处理下，加一个状态标识，以便在props.data第一次不为空的情况下，取值于defaultChecked，而不是取值于checked
       */
    };_this.initial = true;
    /**
     * 存储Tree, List组件的原有数据和事件
     */
    _this.menuProps = {
      data: [],
      onExpand: _util.noop,
      onSelect: _util.noop,
      onCheck: _util.noop,
      onChange: _util.noop
      /**
       * 当前下拉菜单中的有效组件类型，Tree, List
       */
    };_this.menuType = null;
    _this.searchInputRef = 'search-input';
    _this.initializeMenuProps(props);

    /**
     * 存储tree数据的类对象，用于数据搜索
     */
    _this.dataTree; // = new DataTree().import()
    /**
     * 用于阻止事件冒泡，参考react-overlay的做法
     */
    // 用了symbol 命名后，导致栈溢出.. 原因未知
    _this._suppressRootId = '__click_rt_select_was_inside__';
    _this._suppressRootCloseHandler = function (event) {
      event.nativeEvent[_this._suppressRootId] = true;
      event.stopPropagation();
    };
    return _this;
  }

  _createClass(Select, [{
    key: 'componentDidMount',
    value: function componentDidMount() {}
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.unbindRootCloseHandlers();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.initializeMenuProps(nextProps);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          prefixCls = _props.prefixCls,
          children = _props.children,
          onClear = _props.onClear,
          menuStyle = _props.menuStyle,
          emptyDataText = _props.emptyDataText,
          searchInputPlaceholder = _props.searchInputPlaceholder,
          selectToClose = _props.selectToClose,
          search = _props.search,
          otherProps = _objectWithoutProperties(_props, ['className', 'prefixCls', 'children', 'onClear', 'menuStyle', 'emptyDataText', 'searchInputPlaceholder', 'selectToClose', 'search']);

      return _react2.default.createElement(
        'div',
        _extends({}, otherProps, { className: (0, _classnames2.default)(className, prefixCls) }),
        _react2.default.createElement(
          'div',
          { className: prefixCls + '-head', onClick: this.toggleMenuVisible },
          _react2.default.createElement(
            'label',
            { title: this.state.inputValue || this.props.placeholder },
            this.state.inputValue || this.props.placeholder
          ),
          this.state.inputValue && onClear ? _react2.default.createElement(
            'span',
            { className: 'clear-value-icon', onClick: this.clearSelected.bind(this) },
            '\xD7'
          ) : null,
          _react2.default.createElement(
            'div',
            { className: 'dropdown-toggle' },
            _react2.default.createElement('i', null)
          )
        ),
        this.renderMenu()
      );
    }
  }, {
    key: 'renderMenu',
    value: function renderMenu() {
      var _this2 = this;

      var _props2 = this.props,
          prefixCls = _props2.prefixCls,
          children = _props2.children,
          menuStyle = _props2.menuStyle,
          emptyDataText = _props2.emptyDataText,
          search = _props2.search,
          searchInputPlaceholder = _props2.searchInputPlaceholder;
      var _state = this.state,
          menuVisible = _state.menuVisible,
          searchInputValue = _state.searchInputValue;

      var style = _extends({}, menuStyle || {}, { display: menuVisible ? 'block' : 'none' });

      var maxHeight = style.maxHeight,
          otherstyle = _objectWithoutProperties(style, ['maxHeight']);

      return _react2.default.createElement(
        'div',
        { style: otherstyle, className: prefixCls + '-menu', onClick: this._suppressRootCloseHandler },
        _react2.default.Children.map(children, function (child) {
          // 节点为Tree组件时，给它添加相应的属性与事件，以便Tree和Select关联起来
          var elementType = _this2.isValidElement(child);
          if (elementType) {

            // 检查数据是否有更新
            if (child.props !== _this2.menuProps) {
              _this2.updateMenuProps(child, elementType);
            }

            // 这里获取最新数据
            var _state2 = _this2.state,
                data = _state2.data,
                expanded = _state2.expanded;

            var element = void 0;

            if (!data || data.length <= 0) {
              element = _react2.default.createElement(
                'p',
                { className: 'empty-data-text' },
                emptyDataText
              );
            } else {
              var props = {
                data: data,
                bordered: false,
                expanded: expanded,
                onExpand: _this2.onExpand,
                onSelect: _this2.onSelect,
                onCheck: _this2.onCheck,
                onChange: _this2.onChange
              };

              element = _react2.default.cloneElement(child, props);
            }

            // 添加搜索框
            if (search) {
              var _maxHeight = maxHeight || 150;
              element = _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                  'div',
                  { className: 'search-input-wrapper' },
                  _react2.default.createElement('input', {
                    ref: function ref(node) {
                      _this2.searchInput = node;
                    },
                    type: 'text',
                    placeholder: searchInputPlaceholder,
                    value: searchInputValue,
                    onChange: _this2.handleSearchInputChange }),
                  _react2.default.createElement('i', { className: 'icon-search' })
                ),
                _react2.default.createElement(
                  'div',
                  { style: { maxHeight: _maxHeight, overflow: 'auto' } },
                  element
                )
              );
            }

            return element;
          }

          return child;
        })
      );
    }
  }, {
    key: 'initializeMenuProps',
    value: function initializeMenuProps(props) {
      var _this3 = this;

      // TODO: 是否有必要遍历其所有子节点，找到这里需要接管的组件（Tree, List）？
      _react2.default.Children.forEach(props.children, function (child) {
        // 节点为Tree, List组件时，给它添加相应的属性与事件，以便Tree和Select关联起来
        var elementType = _this3.isValidElement(child);
        if (elementType) {
          _this3.updateMenuProps(child, elementType);
          return;
        }
      });
    }
  }, {
    key: 'updateMenuProps',
    value: function updateMenuProps(node, elementType) {
      // 把要接管的组件props存储起来，方便后面使用
      var _node$props = node.props,
          data = _node$props.data,
          expanded = _node$props.expanded,
          defaultExpanded = _node$props.defaultExpanded;


      if (data !== this.menuProps.data) {
        // 重置state
        this.state.data = data;
        this.state.expanded = (this.initial ? expanded || defaultExpanded : expanded) || [];
        // this.state.inputValue = null
        this.state.searchInputValue = '';

        if (this.isTreeElement(elementType)) {
          this.dataTree = new _dataTree2.default().import(data.slice());
          // this.state.data = this.dataTree.export()
        }
      }

      // 如果menuProps.data已有数据，把initial设为false
      this.initial = !(this.initial && this.menuProps.data && this.menuProps.data.length > 0);
      this.menuProps = node.props;
      this.menuType = elementType;
      this.updateInputValue();
    }
  }, {
    key: 'updateInputValue',
    value: function updateInputValue() {
      var _this4 = this;

      var _menuProps = this.menuProps,
          data = _menuProps.data,
          commbox = _menuProps.commbox,
          selected = _menuProps.selected,
          defaultSeleced = _menuProps.defaultSeleced,
          checked = _menuProps.checked,
          defaultChecked = _menuProps.defaultChecked;


      var selectedValues = void 0,
          selectedDatas = [];

      if (commbox) {
        selectedValues = (this.initial ? checked || defaultChecked : checked) || [];
      } else {
        selectedValues = (this.initial ? selected || defaultSeleced : selected) || [];
      }

      // 根据节点选中项设置inputValue
      selectedValues.forEach(function (value) {
        var node = _this4.dataTree.searchDFS(function (data) {
          return data.id === value;
        });
        node && selectedDatas.push(node.data());
      });

      var inputValue = selectedDatas.map(function (o) {
        return o.text;
      }).join(', ');
      this.initial ? this.state.inputValue = inputValue : this.setState({ inputValue: inputValue });
    }

    /**
     * 判断是否有效的Tree, List组件，如果是，返回组件的类型，否则还回false
     * 由于并不依懒于Tree, List组件，所以这里仅以它的displayName来判断
     */

  }, {
    key: 'isValidElement',
    value: function isValidElement(element) {
      var elementType = element.type ? element.type.elementType : undefined;
      return elementType && (this.isTreeElement(elementType) || this.isListElement(elementType)) ? elementType : false;
    }
  }, {
    key: 'isTreeElement',
    value: function isTreeElement(elementType) {
      return (elementType || this.menuType) === _util.TREE_ELEMENT;
    }
  }, {
    key: 'isListElement',
    value: function isListElement(elementType) {
      return (elementType || this.menuType) === _util.LIST_ELEMENT;
    }
  }, {
    key: 'bindRootCloseHandlers',
    value: function bindRootCloseHandlers() {
      var doc = (0, _util.ownerDocument)(this);
      this._onDocumentClickListener = (0, _util.addEventListener)(doc, 'click', this.handleDocumentClick);
    }
  }, {
    key: 'unbindRootCloseHandlers',
    value: function unbindRootCloseHandlers() {
      if (this._onDocumentClickListener) {
        this._onDocumentClickListener.remove();
      }
    }
  }, {
    key: 'handleDocumentClick',
    value: function handleDocumentClick(e) {
      // This is now the native event.
      if (e[this._suppressRootId]) {
        return;
      }
      this.toggleMenuVisible();
    }
  }, {
    key: 'toggleMenuVisible',
    value: function toggleMenuVisible() {
      var _this5 = this;

      this.setState({
        menuVisible: !this.state.menuVisible
      }, function () {
        if (_this5.state.menuVisible) {
          _this5.bindRootCloseHandlers();

          // 让搜索框获得焦点
          if (_this5.props.search) {
            var input = _this5.searchInput;
            input && input.focus();
          }
        } else if (!_this5.state.menuVisible) {
          _this5.unbindRootCloseHandlers();
        }
      });
    }
  }, {
    key: 'onExpand',
    value: function onExpand(expanded, node) {
      var nodeValue = node.props.value;
      // 这里维护Tree.props.expanded的值，因为在搜索时，会用到
      this.setState({
        expanded: expanded ? [].concat(_toConsumableArray(this.state.expanded), [nodeValue]) : this.state.expanded.filter(function (item) {
          return item !== nodeValue;
        })
      });
      this.menuProps.onExpand(expanded, node);
    }
  }, {
    key: 'onSelect',
    value: function onSelect(selected, value, data, node) {
      return this.onEvent('select', selected, value, data, node);
    }
  }, {
    key: 'onCheck',
    value: function onCheck(checked, value, data, node) {
      return this.onEvent('check', checked, value, data, node);
    }
  }, {
    key: 'onEvent',
    value: function onEvent(eventType, selected, value, data, node) {
      var selectToClose = this.props.selectToClose;
      var _menuProps2 = this.menuProps,
          multiple = _menuProps2.multiple,
          onSelect = _menuProps2.onSelect,
          onCheck = _menuProps2.onCheck;

      var result = void 0;

      switch (eventType) {
        case 'select':
          result = onSelect(selected, value, data, node);break;
        case 'check':
          result = onCheck(selected, value, data, node);break;
      }

      if (!multiple && selected && selectToClose && result !== false) {
        this.toggleMenuVisible();
      }

      return result;
    }
  }, {
    key: 'selectToClose',
    value: function selectToClose() {
      var selectToClose = this.props.selectToClose;
      var multiple = this.menuProps.multiple;
      // 单选时，如果选中了选项，关闭下拉菜单

      if (!multiple && selected && selectToClose) {
        this.toggleMenuVisible();
      }
    }
  }, {
    key: 'onChange',
    value: function onChange(value, data, node) {
      this.menuProps.onChange(value, data, node);
    }
  }, {
    key: 'setInputValue',
    value: function setInputValue(data, initial) {
      var inputValue = void 0;
      // 把数据更新到input
      if (data) {
        if (Array.isArray(data)) {
          data.length > 0 && (inputValue = data.map(function (o) {
            return o.text;
          }).join(', '));
        } else {
          inputValue = data.text;
        }
      }
      initial ? this.state.inputValue = inputValue : this.setState({ inputValue: inputValue });
    }
  }, {
    key: 'clearSelected',
    value: function clearSelected(e) {
      e.stopPropagation();
      this.props.onClear && this.props.onClear();
    }
  }, {
    key: 'handleSearch',
    value: function handleSearch(flag) {
      var searchInputValue = this.searchInput && this.searchInput.value;
      var result = void 0;

      // 使用输入法时，每次keyDown都会触发该onChange事件，但input的值实际上还没变更，这里判断一下
      if (searchInputValue !== this.state.searchInputValue || flag) {
        // 过滤节点数据
        if (this.isTreeElement()) {
          result = this.filterTreeDatas(searchInputValue);
        } else {
          result = this.filterListDatas(searchInputValue);
        }

        this.setState(_extends({}, result || {}, {
          searchInputValue: searchInputValue
        }));
      }
    }

    // 防抖

  }, {
    key: 'handleSearchInputChange',
    value: function handleSearchInputChange() {
      var _this6 = this;

      var delay = Number(this.props.delay) || 0;
      var searchInputValue = this.searchInput && this.searchInput.value;
      this.setState({
        searchInputValue: searchInputValue
      });
      if (delay > 0) {
        if (this._searchTimer) {
          (0, _timers.clearTimeout)(this._searchTimer);
        }
        this._searchTimer = setTimeout(function () {
          _this6.handleSearch(true);
          _this6._searchTimer = null;
        }, delay);
        return;
      }
      this.handleSearch();
    }
  }, {
    key: 'filterTreeDatas',
    value: function filterTreeDatas(keyWord) {
      var _this7 = this;

      var data = this.menuProps.data;

      var expanded = [];
      if (!keyWord) {
        return { data: data };
      }
      // 重置树节点数据
      var tree = this.dataTree;
      tree.import(data.slice());
      // 使用深度优先搜索算法搜索树节点
      tree.traverseDFS(function (node) {
        // 如果存在多各根节点的情形
        if (node._depth == 1 && node._childNodes.length > 1) {
          node._childNodes.forEach(function (nodeItem) {
            _this7.loopDFS_keyWord(nodeItem, expanded, keyWord);
          });
        } else {
          _this7.loopDFS_keyWord(node, expanded, keyWord);
        }
      });

      var afterFilter = this.filterExpanedTree(tree.export());
      // 重置
      this.dataTree.import(data.slice());
      // 只搜索到一个节点时，不展开该节点
      if (expanded.length === 1) return { data: afterFilter, expanded: [] };else if (expanded.length > 1) return { data: afterFilter, expanded: expanded };else return { data: null };
    }
  }, {
    key: 'loopDFS_keyWord',
    value: function loopDFS_keyWord(node, expanded, keyWord) {
      var _this8 = this;

      var nodeData = node.data();
      // 添加大小写忽略
      if (nodeData.text.toUpperCase().indexOf(keyWord.toUpperCase()) > -1) {
        // 将自身放到map中
        expanded.push(nodeData.id);
        Object.assign(nodeData, { expanded: true });
        // 获取它所有的祖先节点 把它的ID放到map中
        node.getAncestry().forEach(function (item) {
          var id = item.data().id;
          item.data(_extends({}, item.data(), { expanded: true }));
          if (_this8.contains(id, expanded) === false) {
            expanded.push(id);
          }
        });
        // 获取所有的子节点 并把ID放到map中
        node.childNodes().forEach(function (item) {
          var id = item.data().id;
          item.data(_extends({}, item.data(), { expanded: true }));
          if (_this8.contains(id, expanded) === false) {
            expanded.push(id);
          }
        });
      } else if (this.contains(nodeData.id, expanded) === false) {
        // 为了避免父级匹配而添加上的子节点被重置expanded为false 增加判断
        // 为避免上次记录被保存，没有展开的再次遍历，设置false
        Object.assign(nodeData, { expanded: false });
      }
    }

    // 数组中是否包含  

  }, {
    key: 'contains',
    value: function contains(id, arr) {
      var bool = false;
      arr.map(function (item) {
        if (item == id) {
          return bool = true;
        }
      });
      return bool;
    }

    // 对过滤展开的树进行递归筛选

  }, {
    key: 'filterExpanedTree',
    value: function filterExpanedTree(treeDatas) {
      var _this9 = this;

      var tree = [];
      var loopTree = function loopTree(trees, store) {
        Array.isArray(trees) && trees.map(function (item) {
          if (item.expanded === true) {
            var children = item.children,
                node = _objectWithoutProperties(item, ['children']);

            var childrens = _this9.childNodeHasExpaned(item.children) ? [] : item.children;
            Object.assign(node, { children: childrens });
            store.push(node);
            loopTree(item.children, node.children);
          }
        });
      };
      loopTree(treeDatas, tree);
      return tree;
    }
  }, {
    key: 'filterListDatas',
    value: function filterListDatas(keyWord) {}
    // TODO

    // 判断其孩子中是否包含需要展开的节点。

  }, {
    key: 'childNodeHasExpaned',
    value: function childNodeHasExpaned(children) {
      // 假设没有
      var bool = false;
      Array.isArray(children) && children.forEach(function (item) {
        if (item.expanded === true) {
          return bool = true;
        }
      });
      return bool;
    }
  }]);

  return Select;
}(_react2.default.Component);

Select.propTypes = {
  /**
   * 下拉菜单的style
   * @type {Object}
   */
  menuStyle: _propTypes2.default.object,
  /**
   * 数据为空时，显示的文本信息
   * @type {String}
   */
  emptyDataText: _propTypes2.default.string,
  /**
   * 是否启用节点过滤功能
   * @type {Boolean}
   */
  search: _propTypes2.default.bool,
  /**
   * 查询框的placeholder值
   */
  searchInputPlaceholder: _propTypes2.default.string,
  /**
   * 选中时，是否自动关闭下拉菜单（仅单选有效）
   */
  selectToClose: _propTypes2.default.bool,
  /**
   * onClear 
   */
  onClear: _propTypes2.default.func,
  /**
   * [placeholder description]
   * @type {[type]}
   */
  placeholder: _propTypes2.default.string
};

Select.defaultProps = {
  prefixCls: 'rt-select',
  emptyDataText: '没有可显示的数据',
  searchInputPlaceholder: '搜索',
  selectToClose: true
};

exports.default = Select;